/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package de.laliluna.example.struts.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.displaytag.tags.TableTagParameters;
import org.displaytag.util.ParamEncoder;

import de.laliluna.example.service.HedgehogService;
import de.laliluna.example.service.HedgehogServiceImp;
import de.laliluna.example.service.HedgehogService.SortBy;
import de.laliluna.example.struts.Globals;

public class ShowHedgehogsAction extends Action {
	private static org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(ShowHedgehogsAction.class);

	/**
     * Method execute
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return ActionForward
     */
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response) {

		HedgehogService hedgehogService = new HedgehogServiceImp();

		/* determine sort order */
		String sortColumn = (String) request.getParameter(new ParamEncoder(
				"dtable")
				.encodeParameterName(TableTagParameters.PARAMETER_SORT));
		String sortOrder = (String) request.getParameter(new ParamEncoder(
				"dtable")
				.encodeParameterName(TableTagParameters.PARAMETER_ORDER));

		log.debug("Sort: " + sortColumn + "##" + sortOrder);
		SortBy sortBy = null;
		if (sortColumn != null) {
			if (sortColumn.equals("name")) {
				if (sortOrder != null && sortOrder.equals("2"))
					sortBy = SortBy.NAME_DESC;
				else
					sortBy = SortBy.NAME_ASC;
			} else // default or id column
			{
				if (sortOrder != null && sortOrder.equals("2"))
					sortBy = SortBy.ID_DESC;
				else
					sortBy = SortBy.ID_ASC;

			}
		} else
			sortBy = SortBy.ID_ASC; // default sort order

		/* determine page to display */
		String sPage = request
								.getParameter(new ParamEncoder("dtable")
										.encodeParameterName(TableTagParameters.PARAMETER_PAGE));
		int page = 0;
		if (sPage != null)
			page = Integer.parseInt(sPage);
		/* example calculation: page 3 starts with item 10 */
		int firstItem = (page - 1 )*5;
		
		request.setAttribute("hedgehogs", hedgehogService.findSubset(firstItem, firstItem+5,
				sortBy));
		/* count all items */
		request.setAttribute("total", hedgehogService.countAllHedgehogs());
		
		return mapping.findForward(Globals.SUCCESS);
	}
}