
package de.laliluna.component.collection1;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;
import org.hibernate.LockOptions;
import org.hibernate.Session;

import java.util.List;

/**
 * @author hennebrueder
 *
 */
public class TestCollection1 extends BasicTest {


	public static void main(String[] args) {
	Hedgehog hedgeHog =	create();
	update(hedgeHog);
	query();

	}

	private static void query() {
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		List<Hedgehog> list = session.createQuery("from Hedgehog h left join h.addresses a where a.name = ?").setString(0, "first class hotel").list();
		for (Hedgehog hedgehog : list) {
			System.out.println(hedgehog);
		}
		
		session.getTransaction().commit();
		
	}

	private static void update(Hedgehog hedgehog) {
		log.debug("update");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		// reattach hedgehog as session could have been closed
		session.buildLockRequest(LockOptions.NONE).lock(hedgehog);
		//delete first and add a new address
		hedgehog.getAddresses().remove(0);
		
		WinterAddress newAddress = new WinterAddress("first class hotel", "down the road");
		hedgehog.getAddresses().add(newAddress);
		
		session.getTransaction().commit();
		
	}

	private static Hedgehog create() {
		log.debug("create");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		Hedgehog hedgehog = new Hedgehog("Peter");
		WinterAddress address1 = new WinterAddress("stack of wood", "close to the apple tree");
		WinterAddress address2 = new WinterAddress("shelter", "old shelter of the neighbour");
		hedgehog.getAddresses().add(address1);
		hedgehog.getAddresses().add(address2);
		session.save(hedgehog);
		session.getTransaction().commit();
		return hedgehog;
	}

}
