
package de.laliluna.inheritance.xmlinclude;

import java.util.Iterator;
import java.util.List;

import org.hibernate.Session;

import de.laliluna.example.BasicTest;
import de.laliluna.hibernate.InitSessionFactory;


public class TestXmlInclude extends BasicTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		create();

		query();

	}

	private static void query() {
		log.debug("query");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		List list = null;
		session.beginTransaction();

		log.debug("select all OldHardrockGroups");
		list = session.createQuery("from OldHardrockGroup").list();
		for (Iterator iter = list.iterator(); iter.hasNext();) {
			OldHardrockGroup element = (OldHardrockGroup) iter.next();
			log.debug("{}", element);
		}

		log.debug("select all OldMusicGroup");
		list = session.createQuery("from de.laliluna.inheritance.xmlinclude.OldMusicGroup").list();
		for (Iterator iter = list.iterator(); iter.hasNext();) {
			log.debug("{}", iter.next());
		}

		/*
		 * select all musicFans of hardrockgroups having destroyed more than 150
		 *  + " (select hg.id from OldHardrockGroup hg where hg.destroyedGuitars >
		 * 150)"
		 */
		log.debug("select all  musicFans of hardrockgroups");
		list = session
				.createQuery(
						"select mf from OldMusicFan mf left join mf.musicGroups mg where mg.id  in "
								+ "(select hg.id from OldHardrockGroup  hg where hg.destroyedGuitars > 150) ")
				.list();

		for (Iterator iter = list.iterator(); iter.hasNext();) {

			log.debug("{}", iter.next());
		}

		session.getTransaction().commit();

	}

	private static OldMusicFan create() {
		log.debug("create");
		Session session = InitSessionFactory.getInstance().getCurrentSession();
		session.beginTransaction();
		OldMusicFan musicFan = new OldMusicFan("Edwin");
		OldHardrockGroup hardrockGroup = new OldHardrockGroup();
		hardrockGroup.setName("very brutal");
		hardrockGroup.setDestroyedGuitars(200);
		musicFan.getMusicGroups().add(hardrockGroup);
		OldBoyGroup boyGroup = new OldBoyGroup();
		boyGroup.setName("nice guys");
		boyGroup.setCryingGroupies(true);
		musicFan.getMusicGroups().add(boyGroup);
		// save the payment methods first, because the shop needs the primary
		// keys
		session.save(boyGroup);
		session.save(hardrockGroup);
		session.save(musicFan);
		session.getTransaction().commit();
		return musicFan;
	}

}
