
package de.laliluna.primarykey.complex;

import java.io.Serializable;
import java.text.MessageFormat;

/**
 * @author hennebrueder
 */

public class BoxTurtleId implements Serializable {

	private String location;

	private String favouriteSalad;

	public BoxTurtleId() {
		super();
	}

	public BoxTurtleId(String location, String favoriteSalad) {
		super();
		this.location = location;
		this.favouriteSalad = favoriteSalad;
	}

	@Override
	public String toString() {
		return MessageFormat.format("{0} location={1}, favoriteSalad={2}",
				new Object[] { getClass().getSimpleName(), location,
						favouriteSalad });
	}

	public String getFavouriteSalad() {
		return favouriteSalad;
	}

	public void setFavouriteSalad(String favoriteSalad) {
		this.favouriteSalad = favoriteSalad;
	}

	public String getLocation() {
		return location;
	}

	public void setLocation(String location) {
		this.location = location;
	}

	/*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#hashCode()
     */
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result
				+ ((favouriteSalad == null) ? 0 : favouriteSalad.hashCode());
		result = PRIME * result
				+ ((location == null) ? 0 : location.hashCode());
		return result;
	}

	/*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#equals(java.lang.Object)
     */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final BoxTurtleId other = (BoxTurtleId) obj;
		if (favouriteSalad == null) {
			if (other.favouriteSalad != null)
				return false;
		} else if (!favouriteSalad.equals(other.favouriteSalad))
			return false;
		if (location == null) {
			if (other.location != null)
				return false;
		} else if (!location.equals(other.location))
			return false;
		return true;
	}

}
