package com.example.newapp.domain;

import org.apache.tapestry5.ioc.annotations.Inject;

import javax.persistence.*;
import java.util.Date;


@Entity
public class Book {

    @GeneratedValue
    @Id
    private Integer id;
    private String title;

    @Lob
    private String description;

    @Temporal(TemporalType.DATE)
    private Date published;

    @Inject
    public Book() {
    }

    public Book(String title, Date published) {
        this.title = title;
        this.published = published;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder();
        sb.append("Book");
        sb.append("{id=").append(id);
        sb.append(", title='").append(title).append('\'');
        sb.append(", published=").append(published);
        sb.append('}');
        return sb.toString();
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Date getPublished() {
        return published;
    }

    public void setPublished(Date published) {
        this.published = published;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}
