package com.example.newapp.pages;

import com.example.newapp.domain.Book;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.hibernate.annotations.CommitAfter;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.hibernate.Session;

import java.util.*;

/**
 * Start page of application newapp.
 */
public class Index
{

    @Inject
    private Session session;

    /**
     * Used in the grid as current loop value property
     */
    @Property
    private Book book;

	public Date getCurrentTime() 
	{
        Calendar c = GregorianCalendar.getInstance();
        c.add(Calendar.MONTH, 5);
        return c.getTime();
	}

    /**
     * @CommitAfter causes a commit right after the method was executed.
     *
     * @return
     */
    @CommitAfter
    public Object onActionFromCreateRandomBook(){
        session.save(new Book("Hibernate " + new Random().nextInt(100), new Date()));
        /**
         * return null to stay on the same page.
         */
        return null;
    }

    public List<Book> getAllBooks(){
        return session.createQuery("select b from Book b").list();
    }
}
